#include <iostream>
#include <fstream>
#include "BE.h"
#include "GM.h"
#include "Graph.h"
#include <cmath>

int main(int argc, char* argv[])
{
  GM gm;
  int num_evidence=0;
  vector<int> evidence;	
  vector<set<int> > clusters;
  double estimate;
  if (!gm.readCNF(argv[1])){
    gm.readUAI08(argv[1]);
    ifstream in(argv[2]);
    if(in.good())
    {
      in>>num_evidence;
      for(int i=0;i<num_evidence;i++)
	{
	  int var,val;
	  in>>var>>val;
	  gm.variables[var]->value()=val;
	  evidence.push_back(var);
	}
    }
  }
  else {
    num_evidence=gm.clauses.size();
  }
  vector<int> order;
  //Read evidence

  //gm.mode=POSITIVE;
  //char buffer[100];
  //in.getline(buffer,100);

  
  gm.removeIrrelevantNetwork(evidence);
  
  if ((int)gm.variables.size()<1000){
    gm.getMinFillOrdering(order,clusters,estimate);
  }
  else {
    gm.getMinDegreeOrdering(order,clusters,estimate);
  }
  ofstream out(argv[3]);
  out<<gm.variables.size()<<",";
  int dom_size=0;
  for(int i=0;i<gm.variables.size();i++){
    dom_size+=gm.variables[i]->domain_size();
  }
  out<<dom_size/(int)gm.variables.size()<<",";
  out<<num_evidence<<",";
  unsigned int treewidth=0;
  for(int i=0;i<clusters.size();i++){
    if (clusters[i].size() > treewidth){
      treewidth=clusters[i].size();
    }
  }
  out<<treewidth-1<<endl;
}
