#include <iostream>
#include <fstream>
#include "SampleSearch.cpp"
#include "BE.h"
#include "GM.h"
#include "Graph.h"
#include "RB_IJGP_Sampler.h"
#include <cmath>

using namespace std;
#include <sys/time.h>
#include <sys/resource.h>
static inline double get_cpu_time(void) 
{
  struct rusage ru;
  getrusage(RUSAGE_SELF, &ru);
  return (double)ru.ru_utime.tv_sec + (double)ru.ru_utime.tv_usec / 1000000; 
}


int main(int argc, char* argv[]){

  if (argc < 4){
    cerr<<"Format is uai-file num-evidence evid-file seed\n";
    exit(-1);
  }
  GM gm;
  gm.readUAI08(argv[1]);
  gm.convertToSAT();
  Solver solver;
  gm.convertToSAT();
  gzFile in = gzopen(satfile, "rb");
  parse_DIMACS(in,solver);
  gzclose(in);
  
  int num_evidence=atoi(argv[2]);
  map<int,int> evidence;
  unsigned int seed = atoi(argv[4]);
  srand(time(NULL));
  vec<Lit> assumptions;
  
  for(int i=0;i<num_evidence;i++){
    bool done=false;
    int curr_var=-1;
    do{
      int evid_var=rand()%gm.variables.size();
      if (evidence.find(evid_var)==evidence.end()){
	done=true;
	//evidence.insert(evid_var);
	curr_var=evid_var;
      }
    }
    while(!done);
    
    // Assign value to curr_var
    bool consistent=false;
    do{
      int value=rand()%gm.variables[curr_var]->domain_size();
      assumptions.push(Lit(gm.csp_to_sat_variables[curr_var][value]));
      if (solver.solve(assumptions)){
	consistent=true;
	evidence[curr_var]=value;
      }
      else{
	assumptions.pop();
      }
    }while(!consistent);
  } 
  
  ofstream out(argv[3]);
  out<<num_evidence<<endl;
  for(map<int,int>::iterator i=evidence.begin();i!=evidence.end();i++){
    out<<(*i).first<<" "<<(*i).second<<endl;
  }
  out.close();

  /*
    vector<int> myevidence;
    for(map<int,int>::iterator i=evidence.begin();i!=evidence.end();i++){
    myevidence.push_back((*i).first);
    gm.variables[(*i).first]->value()=(*i).second;
    }
    gm.setEvidenceBeliefsUAI08(myevidence);
    gm.reduceDomains();
  
  */
  
}
  
