import os
import sys


def parse_uai_file(path):
    f=open(path)
    first=True
    count=0
    numvars=-1
    out=[]
    for line in f.readlines():
        if line=='':
            continue
        if first:
            first=False
            continue
        if numvars==-1:
            numvars=int(line.strip('\n').strip(' '))
            continue
        valarray=line.strip('\n').split(' ')
        for i in xrange(numvars):
            out.append(int(valarray[i]))
        break
    f.close()
    return out

def addEvidence(path1,evid_var,evid_val,path2):
    f=open(path1)
    of=open(path2,'w')
    first=True
    for line in f.readlines():
        if first:
            first=False
            num_evidence=int(line.strip('\n').strip(' '))
            of.write(str(num_evidence+1)+'\n')
            continue
        of.write(line)
    f.close()
    of.write(str(evid_var)+' '+str(evid_val)+'\n')
    of.close()

def parse_uai_evid_file(path):
    f=open(path)
    d={}
    first=True
    for line in f.readlines():
        if first:
            first=False
            num_evidence=int(line.strip('\n').strip(' '))
            continue
        format=line.strip('\n').strip(' ').split(' ')
        d[int(format[0])]=int(format[1])
    f.close()
    return d

if len(sys.argv)<4:
    print 'format is script <uaifilename> <margfile> <num-evidence>'
    sys.exit(-1)
    

os.system('./genevid '+sys.argv[1]+' '+sys.argv[3]+' '+sys.argv[1]+'.evid 1000 >t')
os.system('rm pe.out')
os.system('./boundedvec '+sys.argv[1]+' '+sys.argv[1]+'.evid 10000 >t')
f=open('pe.out')
sol_found=False
pe=-1.2
for line in f.readlines():
    if line.find('I')>-1:
        break
    else:
        pe=float(line.strip('\n').strip(' '))
f.close()

if pe < 0.0:
    print 'something terribly wrong\n'
    sys.exit(-1)

valarray=parse_uai_file(sys.argv[1])
d=parse_uai_evid_file(sys.argv[1]+'.evid')

f=open(sys.argv[2],'w')
f.write(str(len(valarray))+' '+str(pe)+'\n')
for i in xrange(len(valarray)):
    os.system('rm t')
    f.write(str(i)+' '+str(valarray[i])+' ')
    if d.has_key(i):
        for j in xrange(valarray[i]):
            if j==d[i]:
                f.write('1 ')
            else:
                f.write('0 ')
        f.write('\n')
        continue
    margs=[]
    valid_margs=True
    print '***************'
    print 'processing Var '+str(i)+' out of '+str(len(valarray))
    print '**************'
    for j in xrange(valarray[i]):
        os.system('rm pe.out')
        addEvidence(sys.argv[1]+'.evid',i,j,'tmp.evid')
        os.system('./boundedvec '+sys.argv[1]+' tmp.evid 10000 2>&1 > t')
        of=open('pe.out')
        sol_found=False
        pe=0.0
        for line in of.readlines():
            if line.find('I')>-1:
                break
            else:
                curr_pe=float(line.strip('\n').strip(' '))
                margs.append(curr_pe)
                sol_found=True
        of.close()
        if sol_found==False:
            valid_margs=False
            break
    if valid_margs:
        for j in xrange(len(margs)):
            f.write(str(margs[j])+' ')
    else:
        for j in xrange(len(valarray[i])):
            f.write('0 ')
    f.write('\n')
    os.system('rm pe.out')
    os.system('rm t')

        
    
    

    
        
            
