#ifndef GM_H_
#define GM_H_

#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include "Double.h"

using namespace std;
#include "Variable.h"
#include "Function.h"

#define INVALID_VALUE -1

// A graphical model has Random Variables and Functions

struct GM
{
	vector<Variable*> variables;
	vector<Function*> functions;
	vector<int> sat_to_csp_variables;
	Double mult_factor;
	vector<vector <int> > csp_to_sat_variables;
	vector<int> var_to_ids;
	GM():mult_factor(Double(1.0)){}
	bool readCNF(char* infile);
	bool readCF(char* infile);
	bool readVIB(char* infile);
	void convertToSAT();
	void readEvidenceErgo(char* evidencefile);
	void readEvidenceVIB(char* evidencefile);
	void readEvidence1(char* evidencefile);
	void writeConstraintGraph(char* cgraph);
	void convertToCN(GM& cn);
	void readErgo(char* infile);
	void reduceBN(GM* gm, int i_bound, vector<int>& order);
	void writeErgo(char* outfile);
};



#endif