#ifndef SAMPLESEARCH_H_
#define SAMPLESEARCH_H_

#include "GM.h"
#include "JG.h"
#include "IJGPSamplingHelper.h"
#include "Vec.h"

#include "Heap.h"
#include "Alg.h"
#include "SolverTypes.h"
class SampleSearch
{
private:
	GM& gm;
	JG& jg;
	vector<int> order;
	IJGPSamplingHelper helper;
	Double getWeight(vec<lbool>& assignment);
	myRandom random;
public:
	SampleSearch(GM& gm, JG& jg, int p_bound, vector<int>& order);
	Double computePE(int time_limit, int num_samples=INVALID_VALUE);
	void computeBeliefs(int time_limit, int num_samples, vector<vector<Double> >& beliefs);
	int getSample(int& variable, bool& value, vec<char>& assignment);
};
#endif