
#include "GM.h"
#include "JG.h"
#include "Graph.h"
#include <cmath>
#include <cstdlib>

#include "HyperGraph.h"



int main(int argc, char* argv[])
{
	if(argc < 5)
	{
		cerr<<"Format is: "<<argv[0]<<" bnfile evidfile i-bound outfile\n";
		exit(1);
	}
	GM gm;
	gm.readErgo(argv[1]);
	gm.readEvidenceErgo(argv[2]);
	int i_bound;
	sscanf(argv[3],"%d",&i_bound);
	vector<int> order;
	vector<int> sampling_order;
	int num_components=3;
	if(1)
	{
		Graph g;
		g.makeGraph(&gm);
		g.getMinFillOrdering(order);
	}
	JG jg(gm,i_bound,10,order,LS);

	HyperGraph hg;
	hg.edges=vector<set<int> > (gm.variables.size());
	for(int i=0;i<jg.nodes.size();i++)
	{
		if(jg.nodes[i]->variables().empty())
			continue;
		set<int> curr_vertex;
		for(int j=0;j<jg.nodes[i]->variables().size();j++)
		{
			curr_vertex.insert(jg.nodes[i]->variables()[j]->id());
			hg.edges[jg.nodes[i]->variables()[j]->id()].insert(i);
		}
		hg.vertices.push_back(curr_vertex);
	}
	for(int i=0;i<hg.edges.size();i++)
	{
		hg.edge2varindex[i]=i;
		hg.var2edgeindex[i]=i;
	}
	for(int i=0;i<hg.vertices.size();i++)
	{
		hg.func2vertexindex[i]=i;
		hg.vertex2funcindex[i]=i;
	}
	hg.computeOrdering(num_components,sampling_order);

	// Write the order to the file
	ofstream out(argv[4]);
	out<<gm.variables.size()<<endl;
	for(int i=0;i<order.size();i++)
	{
		out<<order[i]<<endl;
	}
	for(int i=0;i<sampling_order.size();i++)
	{
		out<<sampling_order[i]<<endl;
	}
	out.close();
}