#include <iostream>
#include <fstream>
#include "SampleSearch.cpp"
#include "BE.h"
#include "GM.h"
#include "Graph.h"
#include "RB_IJGP_Sampler.h"
#include <cmath>

using namespace std;
#include <sys/time.h>
#include <sys/resource.h>
static inline double get_cpu_time(void) 
{
  struct rusage ru;
  getrusage(RUSAGE_SELF, &ru);
  return (double)ru.ru_utime.tv_sec + (double)ru.ru_utime.tv_usec / 1000000; 
}

#define LIMIT 10000000
int main(int argc, char* argv[])
{
	int i_bound,p_bound=0,w_bound=0,num_samples=-1,time_limit=10,num_iterations=10;
	GM gm;
	//gm.readErgo(argv[1]);
	gm.readUAI08(argv[1]);
	vector<int> order;
	//Read evidence
	ifstream in(argv[2]);
	//gm.mode=POSITIVE;
	//char buffer[100];
	//in.getline(buffer,100);
	int num_evidence=0;
	vector<int> evidence;
	if(in.good())
	{
		in>>num_evidence;
		for(int i=0;i<num_evidence;i++)
		{
			int var,val;
			in>>var>>val;
			gm.variables[var]->value()=val;
			evidence.push_back(var);
		}
	}
	vector<set<int> > clusters;
	double estimate;
	double limit=(double)LIMIT;
	//sscanf(argv[4],"%lf",&limit);
	//sscanf(argv[5],"%d",&i_bound);
	if(gm.type == BAYES)
	{
		gm.removeIrrelevantNetwork(evidence);
		
		if(gm.mode == DET)
		{
		  gm.reduceDomains();
		}
		//	GM csp;
		//	gm.convertToCN(csp);
		//	Graph g;
		//	g.makeGraph(&csp);
		//	g.getMinFillOrdering(order);
		//	gm.getClusters(order,clusters);
		//}
		//else
		//{
		gm.getMinFillOrdering(order,clusters,estimate);
			//	}
	}
	else if (gm.type == MARKOV)
	{
		gm.removeIrrelevantNetwork(evidence);
		if(gm.mode == DET)
		{
		  gm.reduceDomains();
		}
		gm.getMinFillOrdering(order,clusters,estimate);
		
	}
	cerr<<"num evidence = "<<num_evidence<<endl;
	//Graph graph;
	//graph.makeGraph(&gm);
	//graph.getMinFillOrdering(order);
	
	//
	//BE be(gm.variables,gm.functions,order);

	
	
	cerr<<"Limit = "<<limit<<endl;
	vector<int> new_order;
	gm.rearrangeOrdering(order,clusters,new_order,limit);
	cerr<<"#sampled variables = "<<new_order.size()<<" out of "<<gm.variables.size()<<endl;
	
	//computeIBound(gm,i_bound);
	vector<Variable*> cond_variables(new_order.size());
	for(int i=0;i<new_order.size();i++)
		cond_variables[i]=gm.variables[new_order[i]];
	int num_values=Variable::getDomainSize(cond_variables);
	//Double pe;
	long double pe=0.0;
	cerr<<"num values = "<<num_values<<endl;
	Solver solver;
	
	if(gm.mode==DET){
	  gm.convertToSAT();
	  gzFile in = gzopen(satfile, "rb");
	  parse_DIMACS(in,solver);
	  gzclose(in);
	}
	int n=cond_variables.size();
	int a[n];
	int f[n+1];
	int o[n];
	int m[n];
	// Initialize
	for(int i=0;i<n;i++){
	  cond_variables[i]->value()=0;
	  a[i]=0;
	  f[i]=i;
	  o[i]=1;
	  m[i]=cond_variables[i]->domain_size();
	}
	f[n]=n;
	cout <<"t "<<get_cpu_time()<<endl;
	 
	while (1)
	{
	  bool has_sol=true;
	  if(gm.mode == DET){
	    vec<Lit> assumptions;
	    for(int j=0;j<cond_variables.size();j++){
	      int id=cond_variables[j]->id();
	      int value=cond_variables[j]->value();
	      assumptions.push(Lit(gm.csp_to_sat_variables[id][value]));
	    }
	    if(!solver.solve(assumptions)){
	      has_sol=false;
	    }
	  }
	  if(has_sol){
	    BE be(gm.variables,gm.functions,order);
	    //pe+=be.log_pe.toDouble();
	    pe+=exp(be.log_pe.toLongdouble());
	  }
	 
	  //Double tmp(pe);
	  //tmp*=gm.mult_factor;
	  long double tmp=pe;
	  tmp*=gm.mult_factor.value();
	  if(tmp>0.0)
	    cout<<"z "<<log10(tmp)<<endl;
	  int j=f[0];
	  f[0]=0;
	  if(j==n)
	    break;
	  a[j]=a[j]+o[j];
	  cond_variables[j]->value()=a[j];
	  if(a[j]==0 || a[j]==(m[j]-1)){
	    o[j]=-o[j];
	    f[j]=f[j+1];
	    f[j+1]=j+1;
	  }
	}
	
	
	//pe*=gm.mult_factor;
	pe*=gm.mult_factor.value();
	cerr<<"---------------------------RESULT------------------------------\n";
	cerr<<"\t Log Base e probability of evidence = "<<log(pe)<<endl;
	cerr<<"\t Log Base 10 probability of evidence = "<<log(pe)/log((double)10.0)<<endl;
	cerr<<"\t Probability of evidence = "<<pe<<endl;
	cerr<<"---------------------------RESULT------------------------------\n";

	
}
